part of tecfy_core_client_package;

class TitlePathComponenet extends StatefulWidget {
  final String title;
  TitlePathComponenet(this.title);
  @override
  _TitlePathComponenetState createState() => _TitlePathComponenetState();
}

class _TitlePathComponenetState extends State<TitlePathComponenet> {
  Map<int, String> titleLevels;
  int min;
  int max;
  @override
  void initState() {
    super.initState();
    fillData();
  }

  fillData() {
    if(titleLevels != null)return;
    titleLevels = {};
    findLabel(1, InitService.menuItems);
    min = titleLevels.keys.first;
    max = titleLevels.keys.last;
    // print('==============titleLevels================= ${widget.title}');
    // print(titleLevels);
    // print('===============================');
  }

  bool findLabel(int level, List<MenuItem> items) {
    if (items == null) return false;
    var isExist = items.any((e) => e.displayName == widget.title);
    if (!isExist) {
      for (var item in items) {
        titleLevels[level] = item.displayName;
        if (findLabel(level + 1, item.subMenuItems)) return true;
      }
    } else {
      titleLevels[level] = widget.title;
      return true;
    }
    return false;
  }

  @override
  Widget build(BuildContext context) {
    //fillData();
    if(titleLevels.keys.length <= 1) return Container();
    return Row(children: titleLevels.keys.map((e) => getText(e)).toList()
    ..insert(0, Navigator.canPop(context) ? getBackButton() : Container())) ;
  }

  Widget getBackButton(){
    return IconButton(icon:Icon(Icons.arrow_back ),
        onPressed: (){
          Navigator.pop(context);
        });
  }

  Widget getText(int index) {
    Widget text =  Text(
        titleLevels[index],
        style: TextStyle(
          color: index == max
              ? ThemeService.textSubColor
              : ThemeService.secondryColor,
        ),      
    );

    if (index != max) {
      return Row(children: <Widget>[
        text,
        SizedBox(width:3),
        Text('/', style: TextStyle(color: ThemeService.textSubColor)),
        SizedBox(width:3),
      ]);
    }
    return text;
  }
}
